Index: trunk/VUT/work/TestCullingTerrain/TestCullingTerrainApplication.h
===================================================================
--- trunk/VUT/work/TestCullingTerrain/TestCullingTerrainApplication.h	(revision 114)
+++ trunk/VUT/work/TestCullingTerrain/TestCullingTerrainApplication.h	(revision 115)
@@ -1,38 +1,11 @@
-/**
-    \file 
-        TestCullingTerrainApplication.h
-*/
+#ifndef _TestCullingTerrainApplication_H__
+#define _TestCullingTerrainApplication_H__
+
 #include "CEGUIForwardRefs.h"
 #include "ExampleApplication.h"
 #include "OgreTerrainContentGenerator.h"
-#include "VisibilityEnvironment.h"
+
 #include <OgreRenderTargetListener.h>
-#include <vector>
-
-Real timeDelay = 0;
-#define KEY_PRESSED(_key,_timeDelay, _macro) \
-{ \
-    if (mInputDevice->isKeyDown(_key) && timeDelay <= 0) \
-{ \
-    timeDelay = _timeDelay; \
-    _macro ; \
-} \
-}
-
-String mCurrentAlgorithmCaptions[GtpVisibility::VisibilityEnvironment::NUM_CULLING_MANAGERS] = 
-{
-    "View Frustum Culling", 
-	"Stop and Wait Culling", 
-	"Coherent Hierarchical Culling"
-};
-
-/** The information about camera position and orienation per frame */
-typedef struct
-{
-	Vector3 position;
-	Quaternion orientation;
-	Real timeElapsed;
-} frame_info;
-
+#include "TerrainMouseQueryListener.h"
 
 class VisualizationRenderTargetListener: public RenderTargetListener
@@ -46,130 +19,4 @@
 
 	SceneManager *mSceneMgr;
-};
-
-class MouseQueryListener : public ExampleFrameListener, public MouseListener, public MouseMotionListener
-{
-public:
-	
-    MouseQueryListener(RenderWindow* win, Camera* cam, SceneManager *sceneManager, 
-		CEGUI::Renderer *renderer, TerrainContentGenerator *contentGenerator, Camera *vizCamera,
-		SceneNode *camNode);
-
-    ~MouseQueryListener();
-
-	bool frameStarted(const FrameEvent& evt);
-	bool frameEnded(const FrameEvent& evt);
-	bool processUnbufferedKeyInput(const FrameEvent& evt);
-    
-
-    /* MouseListener callbacks. */
-    virtual void mouseClicked(MouseEvent* e) { }
-    virtual void mouseEntered(MouseEvent* e) { }
-    virtual void mouseExited(MouseEvent* e)  { }
-
-    // This is when the mouse button goes DOWN.
-    virtual void mousePressed(MouseEvent* e);
-
-    // This is when the mouse button is let UP.
-    virtual void mouseReleased(MouseEvent* e);
-
-    /* MouseMotionListener callbacks */
-    virtual void mouseMoved (MouseEvent *e);
-   
-    // This is when the mouse is clicked, held and dragged.
-    virtual void mouseDragged (MouseEvent *e);
-
-    void keyPressed(KeyEvent* e);
-
-	void keyReleased(KeyEvent* e);
-	void keyClicked(KeyEvent* e);
-
-	enum  {WALKTHROUGH, REPLAY, STATE_NUM};
-
-	// visualization modes for scene nodes
-	//enum {NODEVIZ_NONE, NODEVIZ_RENDER_NODES, 
-	//	  NODEVIZ_RENDER_NODES_AND_CONTENT, NODEVIZ_MODES_NUM};
-	enum {NODEVIZ_NONE, NODEVIZ_RENDER_GEOMETRY, NODEVIZ_MODES_NUM};
-
-	void nextAlgorithm();
-	void changeThreshold(int incr);
-	void updateStats();
-
-	void toggleUseOptimization();
-	void toggleShowOctree();
-	void toggleUseVisibilityCulling();
-	void toggleShowViz();
-	void nextNodeVizMode();
-	void toggleRecord();
-
-	void zoomVizCamera(int zoom);
-	
-	void addFrameInfo(SceneNode *camNode, Real timeElapsed);
-	void setCurrentFrameInfo(Real timeElapsed);
-
-	void setAppState(int state);
-	void nextAppState();
-
-	void setAlgorithm(int algorithm);
-
-	void moveCamera();
-	
-	void writeFrames();
-	void loadFrames();
-
-	void toggleUseShadows();
-
-protected:
-	void Clamp2Terrain();
-	
-    bool mLMouseDown, mRMouseDown;     // True if the mouse buttons are down
-    SceneManager *mSceneMgr;           // A pointer to the scene manager
-    
-	CEGUI::Renderer *mGUIRenderer;     // cegui renderer
-	
-	bool mShutdownRequested;
-	int mCurrentAlgorithm;
-	int mVisibilityThreshold;
-	
-	OverlayElement *mAlgorithmInfo;
-	OverlayElement *mThresholdInfo;
-	OverlayElement *mFrustumCulledNodesInfo;
-	OverlayElement *mQueryCulledNodesInfo;
-    OverlayElement *mTraversedNodesInfo;
-	OverlayElement *mHierarchyNodesInfo;
-	OverlayElement *mUseOptimizationInfo;
-	OverlayElement *mRenderedNodesInfo;
-	OverlayElement *mObjectsInfo;
-	OverlayElement *mQueriesIssuedInfo;
-
-	SceneNode *mCurrentObject;    // the newly created object
-	int mObjectCount;             // The number of objects on the screen
-
-	RayQueryExecutor *mRayQueryExecutor;
-	TerrainContentGenerator *mTerrainContentGenerator;
-
-	bool mUseOptimization;
-	bool mShowOctree;
-	bool mUseVisibilityCulling;
-	bool mShowVisualization;
-	int mNodeVizMode;
-	bool mCullCamera;
-
-	Real mVizCameraHeight;
-
-	Camera *mVizCamera;
-	SceneNode *mCamNode;
-	
-	//std::deque<Vector3> mWalkList;   // The list of points we are walking to
-	std::vector<frame_info> mFrameInfo;
-		
-	int mCurrentFrame;
-	// the current application state
-	int mAppState;
-	bool mRecord;
-	Real mTimeElapsed;
-	bool mUseShadows;
-
-	bool mVisualizeCulledNodes;
 };
 
@@ -209,5 +56,9 @@
 	VisualizationRenderTargetListener *mRenderTargetListener;
 
+	TerrainMouseQueryListener *mTerrainFrameListener;
+
 private:
 	void chooseSceneManager(void);
 };
+
+#endif // TestCullingTerrainApplication
Index: trunk/VUT/work/ogre_changes/OgreMain/include/OgreHardwareOcclusionQuery.h
===================================================================
--- trunk/VUT/work/ogre_changes/OgreMain/include/OgreHardwareOcclusionQuery.h	(revision 92)
+++ trunk/VUT/work/ogre_changes/OgreMain/include/OgreHardwareOcclusionQuery.h	(revision 115)
@@ -96,32 +96,10 @@
       * Pulls the hardware occlusion query too see if there is a result.
       * @retval NumOfFragments will get the resulting number of fragments.
-	  * @param waitForResult if true, the query will wait until a result is available
-      * @return True if success or false if not.
-	  * @Remarks Hardware occlusion is an assyncronius process the result may take a frame or so.
-	  *			one idea is to test pass1 and if not visible skip pass2. Also note that objects
-	  *			not visible must be tested evrey frame. Visable objects don't need testing every frame.
-	  *			Testing non visable objects can be don unlit, no texture with low LOD object.
-	  *        0 will generate all the levels till 1x1. [default: 0]
-      */
-#ifdef GTP_VISIBILITY_MODIFIED_OGRE
-	  virtual bool pullOcclusionQuery( unsigned int* NumOfFragments, const bool waitForResult ) = 0;
-#else
-	 virtual bool pullOcclusionQuery( unsigned int* NumOfFragments ) = 0;
-#endif
-	/**
-      * Pulls the hardware occlusion query too see if there is a result.
-      * @retval NumOfFragments will get the resulting number of fragments.
-	  * @param waitForResult if true, the query will wait until a result is available
       * @return True if success or false if not.
 	  * @Remarks In DX9 mode specifying OCCLUSIONQUERY_FLUSH as the flag, will case the driver to flush whatever API calls are batched.
 	  * In OpenGL mode it makes no difference if you specify OCCLUSIONQUERY_FLUSH or OCCLUSIONQUERY_NOFLUSH.
       */
-#ifdef GTP_VISIBILITY_MODIFIED_OGRE
-	virtual bool pullOcclusionQuery( unsigned int* NumOfFragments, const bool waitForResult,
-									 const HW_OCCLUSIONQUERY flag  ) = 0; 
-#else
-	  virtual bool pullOcclusionQuery( unsigned int* NumOfFragments, 
-									   const HW_OCCLUSIONQUERY flag  ) = 0; 
-#endif
+	virtual bool pullOcclusionQuery(unsigned int* NumOfFragments, const HW_OCCLUSIONQUERY flag = HWOCCLUSIONQUERY_FLUSH) = 0;
+
 	/**
 	  * Let's you get the last pixel count with out doing the hardware occlusion test
@@ -143,4 +121,19 @@
 	virtual void	setSkipRate( int skip ) = 0;
 	virtual int		getSkipRate() = 0;
+
+#ifdef GTP_VISIBILITY_MODIFIED_OGRE
+	/**
+		Pulls occlusion query.
+		@param NumOfFragments number of visible fragments if query result was available.
+		Last query result if query result was not yet available.
+
+		@param waitForResult if true, the function waits until the result is available.
+		Otherwise the function returns immediately, not waiting for the result.
+		@returns true if query result was available, false if result was not yet available
+	*/
+	virtual bool pullOcclusionQuery( unsigned int* NumOfFragments, const bool waitForResult, 
+		const HW_OCCLUSIONQUERY flag = HWOCCLUSIONQUERY_FLUSH ) = 0; 
+#endif // GTP_VISIBILITY_MODIFIED_OGRE
+
 //----------------------------------------------------------------------
 // Private members
Index: trunk/VUT/work/ogre_changes/OgreMain/include/OgreRenderQueueSortingGrouping.h
===================================================================
--- trunk/VUT/work/ogre_changes/OgreMain/include/OgreRenderQueueSortingGrouping.h	(revision 115)
+++ trunk/VUT/work/ogre_changes/OgreMain/include/OgreRenderQueueSortingGrouping.h	(revision 115)
@@ -0,0 +1,373 @@
+/*
+-----------------------------------------------------------------------------
+This source file is part of OGRE
+    (Object-oriented Graphics Rendering Engine)
+For the latest info, see http://www.ogre3d.org/
+
+Copyright (c) 2000-2005 The OGRE Team
+Also see acknowledgements in Readme.html
+
+This program is free software; you can redistribute it and/or modify it under
+the terms of the GNU Lesser General Public License as published by the Free Software
+Foundation; either version 2 of the License, or (at your option) any later
+version.
+
+This program is distributed in the hope that it will be useful, but WITHOUT
+ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
+
+You should have received a copy of the GNU Lesser General Public License along with
+this program; if not, write to the Free Software Foundation, Inc., 59 Temple
+Place - Suite 330, Boston, MA 02111-1307, USA, or go to
+http://www.gnu.org/copyleft/lesser.txt.
+-----------------------------------------------------------------------------
+*/
+#ifndef __RenderQueueSortingGrouping_H__
+#define __RenderQueueSortingGrouping_H__
+
+// Precompiler options
+#include "OgrePrerequisites.h"
+#include "OgreIteratorWrappers.h"
+#include "OgreMaterial.h"
+#include "OgreTechnique.h"
+#include "OgrePass.h"
+#include "OgreMaterialManager.h"
+
+namespace Ogre {
+
+    /** Renderables in the queue grouped by priority.
+    @remarks
+        This class simply groups renderables for rendering. All the 
+        renderables contained in this class are destined for the same
+        RenderQueueGroup (coarse groupings like those between the main
+        scene and overlays) and have the same priority (fine groupings
+        for detailed overlap control).
+    @par
+        This class optimises the grouped renderables by sorting them by
+        material to reduce render state changes, and outsorts transparent
+        objects.
+    */
+    class RenderPriorityGroup
+    {
+        /** Internal struct reflecting a single Pass for a Renderable. 
+        This is used to sort transparent objects.
+        */
+        struct RenderablePass
+        {
+            /// Pointer to the Renderable details
+            Renderable* renderable;
+            /// Pointer to the Pass
+            Pass* pass;
+
+            RenderablePass(Renderable* rend, Pass* p) :renderable(rend), pass(p) {}
+        };
+
+        /// Comparator to order non-transparent object passes
+        struct SolidQueueItemLess
+        {
+            bool _OgreExport operator()(const Pass* a, const Pass* b) const
+            {
+                // Sort by passHash, which is pass, then texture unit changes
+                unsigned long hasha = a->getHash();
+                unsigned long hashb = b->getHash();
+                if (hasha == hashb)
+                {
+                    // Must differentiate by pointer incase 2 passes end up with the same hash
+                    return a < b;
+                }
+                else
+                {
+                    return hasha < hashb;
+                }
+            }
+        };
+        /// Comparator to order transparent object passes
+        struct TransparentQueueItemLess
+        {
+            const Camera* camera;
+            bool _OgreExport operator()(const RenderablePass& a, const RenderablePass& b) const
+            {
+                if (a.renderable == b.renderable)
+                {
+                    // Same renderable, sort by pass hash
+                    return a.pass->getHash() < b.pass->getHash();
+                }
+                else
+                {
+                    // Different renderables, sort by depth
+                    Real adepth = a.renderable->getSquaredViewDepth(camera);
+                    Real bdepth = b.renderable->getSquaredViewDepth(camera);
+				    if (adepth == bdepth)
+				    {
+                        // Must return deterministic result, doesn't matter what
+                        return a.pass < b.pass;
+				    }
+				    else
+				    {
+				        // Sort DESCENDING by depth (ie far objects first)
+					    return (adepth > bdepth);
+				    }
+                }
+
+            }
+        };
+    public:
+        /** Vector of RenderablePass objects, this is built on the assumption that
+         vectors only ever increase in size, so even if we do clear() the memory stays
+         allocated, ie fast */
+        typedef std::vector<RenderablePass> TransparentRenderablePassList;
+        typedef std::vector<Renderable*> RenderableList;
+        /** Map of pass to renderable lists, used for solid objects since ordering within objects not
+        important. */
+        typedef std::map<Pass*, RenderableList*, SolidQueueItemLess> SolidRenderablePassMap;
+    protected:
+        /// Parent queue group
+        RenderQueueGroup* mParent;
+        bool mSplitPassesByLightingType;
+        bool mSplitNoShadowPasses;
+        /// Solid pass list, used when no shadows, modulative shadows, or ambient passes for additive
+        SolidRenderablePassMap mSolidPasses;
+        /// Solid per-light pass list, used with additive shadows
+        SolidRenderablePassMap mSolidPassesDiffuseSpecular;
+        /// Solid decal (texture) pass list, used with additive shadows
+        SolidRenderablePassMap mSolidPassesDecal;
+        /// Solid pass list, used when shadows are enabled but shadow receive is turned off for these passes
+        SolidRenderablePassMap mSolidPassesNoShadow;
+
+		/// Transparent list
+		TransparentRenderablePassList mTransparentPasses;
+
+        /// Totally empties and destroys a solid pass map
+        void destroySolidPassMap(SolidRenderablePassMap& passmap);
+
+        /// remove a pass entry from all solid pass maps
+        void removeSolidPassEntry(Pass* p);
+
+        /// Clear a solid pass map at the end of a frame
+        void clearSolidPassMap(SolidRenderablePassMap& passmap);
+        /// Internal method for adding a solid renderable
+        void addSolidRenderable(Technique* pTech, Renderable* rend, bool toNoShadowMap);
+        /// Internal method for adding a solid renderable
+        void addSolidRenderableSplitByLightType(Technique* pTech, Renderable* rend);
+        /// Internal method for adding a transparent renderable
+        void addTransparentRenderable(Technique* pTech, Renderable* rend);
+
+    public:
+        RenderPriorityGroup(RenderQueueGroup* parent, 
+            bool splitPassesByLightingType, bool splitNoShadowPasses) 
+            :mParent(parent), mSplitPassesByLightingType(splitPassesByLightingType),
+            mSplitNoShadowPasses(splitNoShadowPasses) { }
+
+        ~RenderPriorityGroup() {
+            // destroy all the pass map entries
+            destroySolidPassMap(mSolidPasses);
+            destroySolidPassMap(mSolidPassesDecal);
+            destroySolidPassMap(mSolidPassesDiffuseSpecular);
+            destroySolidPassMap(mSolidPassesNoShadow);
+            mTransparentPasses.clear();
+
+        }
+
+        /** Get the collection of solid passes currently queued */
+        const SolidRenderablePassMap& _getSolidPasses(void) const
+        { return mSolidPasses; }
+        /** Get the collection of solid passes currently queued (per-light) */
+        const SolidRenderablePassMap& _getSolidPassesDiffuseSpecular(void) const
+        { return mSolidPassesDiffuseSpecular; }
+        /** Get the collection of solid passes currently queued (decal textures)*/
+        const SolidRenderablePassMap& _getSolidPassesDecal(void) const
+        { return mSolidPassesDecal; }
+        /** Get the collection of solid passes for which shadow receipt is disabled*/
+        const SolidRenderablePassMap& _getSolidPassesNoShadow(void) const
+        { return mSolidPassesNoShadow; }
+        /** Get the collection of transparent passes currently queued */
+        const TransparentRenderablePassList& _getTransparentPasses(void) const
+        { return mTransparentPasses; }
+
+
+        /** Add a renderable to this group. */
+        void addRenderable(Renderable* pRend);
+
+		/** Sorts the objects which have been added to the queue; transparent objects by their 
+            depth in relation to the passed in Camera. */
+		void sort(const Camera* cam);
+
+        /** Clears this group of renderables. 
+        */
+        void clear(void);
+#ifdef GTP_VISIBILITY_MODIFIED_OGRE
+		/** Clears solids in this group of renderables. Leaves transparents in group.
+        */
+        void clearSolids(void);
+#endif // GTP_VISIBILITY_MODIFIED_OGRE		
+        /** Sets whether or not the queue will split passes by their lighting type,
+        ie ambient, per-light and decal. 
+        */
+        void setSplitPassesByLightingType(bool split)
+        {
+            mSplitPassesByLightingType = split;
+        }
+
+        /** Sets whether or not passes which have shadow receive disabled should
+            be separated. 
+        */
+        void setSplitNoShadowPasses(bool split)
+        {
+            mSplitNoShadowPasses = split;
+        }
+
+
+    };
+
+
+    /** A grouping level underneath RenderQueue which groups renderables
+    to be issued at coarsely the same time to the renderer.
+    @remarks
+        Each instance of this class itself hold RenderPriorityGroup instances, 
+        which are the groupings of renderables by priority for fine control
+        of ordering (not required for most instances).
+    @par
+        This is an internal OGRE class, not intended for apps to use.
+    */
+    class RenderQueueGroup
+    {
+    public:
+        typedef std::map<ushort, RenderPriorityGroup*, std::less<ushort> > PriorityMap;
+        typedef MapIterator<PriorityMap> PriorityMapIterator;
+    protected:
+        RenderQueue* mParent;
+        bool mSplitPassesByLightingType;
+        bool mSplitNoShadowPasses;
+        /// Map of RenderPriorityGroup objects
+        PriorityMap mPriorityGroups;
+		/// Whether shadows are enabled for this queue
+		bool mShadowsEnabled;
+
+
+    public:
+		RenderQueueGroup(RenderQueue* parent, bool splitPassesByLightingType, 
+            bool splitNoShadowPasses) 
+            :mParent(parent), mSplitPassesByLightingType(splitPassesByLightingType),
+            mSplitNoShadowPasses(splitNoShadowPasses), mShadowsEnabled(true) {}
+
+        ~RenderQueueGroup() {
+            // destroy contents now
+            PriorityMap::iterator i;
+            for (i = mPriorityGroups.begin(); i != mPriorityGroups.end(); ++i)
+            {
+                delete i->second;
+            }
+        }
+
+        /** Get an iterator for browsing through child contents. */
+        PriorityMapIterator getIterator(void)
+        {
+            return PriorityMapIterator(mPriorityGroups.begin(), mPriorityGroups.end());
+        }
+
+        /** Add a renderable to this group, with the given priority. */
+        void addRenderable(Renderable* pRend, ushort priority)
+        {
+            // Check if priority group is there
+            PriorityMap::iterator i = mPriorityGroups.find(priority);
+            RenderPriorityGroup* pPriorityGrp;
+            if (i == mPriorityGroups.end())
+            {
+                // Missing, create
+                pPriorityGrp = new RenderPriorityGroup(this, 
+                    mSplitPassesByLightingType, mSplitNoShadowPasses);
+                mPriorityGroups.insert(PriorityMap::value_type(priority, pPriorityGrp));
+            }
+            else
+            {
+                pPriorityGrp = i->second;
+            }
+
+            // Add
+            pPriorityGrp->addRenderable(pRend);
+
+        }
+
+        /** Clears this group of renderables. 
+        @remarks
+            Doesn't delete any priority groups, just empties them. Saves on 
+            memory deallocations since the chances are rougly the same kinds of 
+            renderables are going to be sent to the queue again next time.
+        */
+        void clear(void)
+        {
+            PriorityMap::iterator i, iend;
+            iend = mPriorityGroups.end();
+            for (i = mPriorityGroups.begin(); i != iend; ++i)
+            {
+                i->second->clear();
+            }
+
+        }
+#ifdef GTP_VISIBILITY_MODIFIED_OGRE	
+		/** Clears only solid renderables. Leaves transparents in queue. */
+		void clearSolids(void)
+        {
+            PriorityMap::iterator i, iend;
+            iend = mPriorityGroups.end();
+            for (i = mPriorityGroups.begin(); i != iend; ++i)
+            {
+                i->second->clearSolids();
+            }
+        }
+#endif // GTP_VISIBILITY_MODIFIED_OGRE		
+
+		/** Indicate whether a given queue group will be doing any
+		shadow setup.
+		@remarks
+		This method allows you to inform the queue about a queue group, and to 
+		indicate whether this group will require shadow processing of any sort.
+		In order to preserve rendering order, OGRE has to treat queue groups
+		as very separate elements of the scene, and this can result in it
+		having to duplicate shadow setup for each group. Therefore, if you
+		know that a group which you are using will never need shadows, you
+		should preregister the group using this method in order to improve
+		the performance.
+		*/
+		void setShadowsEnabled(bool enabled) { mShadowsEnabled = enabled; }
+
+		/** Are shadows enabled for this queue? */
+		bool getShadowsEnabled(void) const { return mShadowsEnabled; }
+
+        /** Sets whether or not the queue will split passes by their lighting type,
+        ie ambient, per-light and decal. 
+        */
+        void setSplitPassesByLightingType(bool split)
+        {
+            mSplitPassesByLightingType = split;
+            PriorityMap::iterator i, iend;
+            iend = mPriorityGroups.end();
+            for (i = mPriorityGroups.begin(); i != iend; ++i)
+            {
+                i->second->setSplitPassesByLightingType(split);
+            }
+        }
+        /** Sets whether or not the queue will split passes which have shadow receive
+        turned off (in their parent material), which is needed when certain shadow
+        techniques are used.
+        */
+        void setSplitNoShadowPasses(bool split)
+        {
+            mSplitNoShadowPasses = split;
+            PriorityMap::iterator i, iend;
+            iend = mPriorityGroups.end();
+            for (i = mPriorityGroups.begin(); i != iend; ++i)
+            {
+                i->second->setSplitNoShadowPasses(split);
+            }
+        }
+
+    };
+
+
+
+}
+
+#endif
+
+
Index: trunk/VUT/work/ogre_changes/OgreMain/include/OgreSceneManager.h
===================================================================
--- trunk/VUT/work/ogre_changes/OgreMain/include/OgreSceneManager.h	(revision 74)
+++ trunk/VUT/work/ogre_changes/OgreMain/include/OgreSceneManager.h	(revision 115)
@@ -128,10 +128,11 @@
 			@param node scene node to be rendered
 			@param cam current camera
+			@param leaveTransparentsInQueue if only solid objects should be rendered
 		*/
-		void _renderSceneNode( Camera *cam, SceneNode *node );
-		/** deletes all queues which we were currently processing
-			@remark clears renderqueue after rendering scene node
+		void _renderSceneNode(Camera *cam, SceneNode *node, bool leaveTransparentsInQueue = false);
+		/** deletes all processed queues
+			@remark clears render queues after rendering scene node
 		*/
-		void _deleteRenderedQueueGroups();
+		void _deleteRenderedQueueGroups(bool leaveTransparentsInQueue);
 		/** Internal method used by _renderVisibleObjects to deal with renderables
             which override the camera's own view / projection materices. 
